var datosIndice=[];
var idPlanta;
var nombrePlanta;

var dataTableIndice;
var mydb;

$(document).ready(function() {
    if ($('#tablaIndice').length>0){
        
        cargarIndice();
    }

    if ($('#detallePlanta').length>0){
        var search = $(location).attr('search')
        idPlanta = search.substring(search.indexOf('idPlanta')+9,search.indexOf('&'));
        nombrePlanta = decodeURI(search.substring(search.indexOf('nombre')+7));
        detallesPlanta();
    }
} );

function cargarIndice(){
    console.log('  cargarIndice');
    document.addEventListener("deviceready", onDeviceReady, true);
}

function detallesPlanta(){
    console.log('  detallePlanta=>idPlanta:'+idPlanta+', nombre='+nombrePlanta);
    //mydb = openDatabase('bdIplantaInterior.bd', '', 'BD Planta interior', 5000000);
    mydb = openDatabase('iPlantaInterior', '1.0', 'iPlantaInterior DB', 100 * 1024);
    mydb.transaction(populateDBDetalle, errorCB, successCB);
}

function onDeviceReady() {
    console.log('      DeviceReady');
    //mydb = openDatabase('bdIplantaInterior.bd', '', 'BD Planta interior', 5000000);
    mydb = openDatabase('iPlantaInterior', '1.0', 'iPlantaInterior DB', 100 * 1024);
    mydb.transaction(populateDB, errorCB, successCB);
}

function populateDB(tx){
    console.log('      PopulateDB');
    tx.executeSql('select DISTINCT NOMEN.ID_PLANTA, NOMEN.NOMBRE, PLANTA.IMAGEN from NOMENCLATURA NOMEN, PLANTA_CATALOGO PLANTA where NOMEN.ID_PLANTA = PLANTA.ID_PLANTA_CATALOGO order by NOMEN.NOMBRE;', [],
        function(transaction, result) {
            if (result != null && result.rows != null) {
                for (var i = 0; i < result.rows.length; i++) {
                    var row = result.rows.item(i);
                    var fila = [''+row.ID_PLANTA,(row.IMAGEN)?''+row.IMAGEN:'', ''+row.NOMBRE];
                    datosIndice.push(fila);
                }
            }

            dataTableIndice = $('#tablaIndice').DataTable({
                "lengthChange": false,
                data: datosIndice,
                "order": [[2, "asc"]],
                "columns": [
                    // Ordenacion y ancho de columnas
                    {},
                    { orderable: false, width: "20%"},
                    {},
                    { orderable: false, width: "10%"},
                ],
                "columnDefs": [
                    {
                        "targets": [0],
                        "visible": false,
                        "searchable": false
                    },
                    {
                        // Renderizacion de las celdas
                        "render": function ( data, type, row ) {
                            if (row[1]!=null && row[1].length>0){
                                return '<img src="' + row[1] + '" alt="Imagen '+row[2]+'"/>';
                            }
                            else{
                                return '';
                            }
                        },
                        "targets": [1]
                    },
                    {
                        // Renderizacion de las celdas
                        "render": function ( data, type, row ) {
                            return '<div class="iconDetalle" id="irDetalleIndice" ident="'+row[0]+'" nombre="'+row[2]+'"><i class="fas fa-arrow-right" ></i></div>';
                        },
                        "targets": [3]
                    }
                ],
                // Traducciones de la tabla
                "language": {
                    "processing":     "Procesando...",
                    "lengthMenu":     "Mostrar _MENU_ registros",
                    "zeroRecords":    "No se encontraron resultados",
                    "emptyTable":     "Ningún dato disponible en esta tabla",
                    "info":           "Mostrando registros del _START_ al _END_ de un total de _TOTAL_ registros",
                    "infoEmpty":      "0 - 0 de 0",
                    "infoFiltered":   "(filtrado de un total de _MAX_ registros)",
                    "infoPostFix":    "",
                    "search":         "Buscar:   ",
                    "thousands":  ",",
                    "loadingRecords": "Cargando...",
                    "paginate": {
                        "first":    "<i class='glyphicon glyphicon-chevron-left'></i><i class='glyphicon glyphicon-chevron-left'></i>",
                        "last":     "<i class='glyphicon glyphicon-chevron-right'></i><i class='glyphicon glyphicon-chevron-right'></i>",
                        "next":     "<i class='glyphicon glyphicon-chevron-right'></i>",
                        "previous": "<i class='glyphicon glyphicon-chevron-left'></i>"
                    },
                    "aria": {
                        "sortAscending":  ": Activar para ordenar la columna de manera ascendente",
                        "sortDescending": ": Activar para ordenar la columna de manera descendente"
                    }
                },
                pageResize: true,
                paging: false,
                info: false
            });
            
        },
    errorHandler);

}



function populateDBDetalle(tx){
    console.log('      PopulateDBDetalle, idPlanta=>'+idPlanta);
    var query = 'select ID_PLANTA_CATALOGO, DESCRIPCION, IMAGEN, LUZ, TEMPERATURA, HUMEDAD, RIEGO, ABONO, TRASPLANTE, LIMPIEZA, PODA, MULTIPLICACION, FLORACION, SUBSTRATO, TRASTORNOS, '
        + ' DESCANSO, INFO_ADICIONAL'
        + ' from PLANTA_CATALOGO where ID_PLANTA_CATALOGO='+idPlanta+';';

        
    tx.executeSql(query, [],
        function(transaction, result) {
            if (result != null && result.rows != null) {
                for (var i = 0; i < result.rows.length; i++) {
                    var row = result.rows.item(i);
                    $('#nombreMigaPan').text(nombrePlanta.toUpperCase());
                    $('#nombreCuidado').html(nombrePlanta.toUpperCase());
                    if (row.IMAGEN!=null  && row.IMAGEN!='null' && row.IMAGEN.length>0){
                        $('#imagen1').attr('src',row.IMAGEN);
                    }
                    else{
                        $('#cardImagen').hide();
                        $("#cardImagen").css("display", "none");
                    }
                    
                    if (row.DESCRIPCION!=null && row.DESCRIPCION.length>0){
                        $('#desCuidado').html(row.DESCRIPCION);
                    }
                    else{
                        $('#cardDescripcion').hide();
                        $("#cardDescripcion").css("display", "none");
                    }

                    if (row.LUZ!=null && row.LUZ.length>0){
                        $('#luzPlanta').html(row.LUZ);
                    }
                    else{
                        $('#cardLuz').hide();
                        $("#cardLuz").css("display", "none");
                    }

                    if (row.TEMPERATURA!=null && row.TEMPERATURA.length>0){
                        $('#temperaturaPlanta').html(row.TEMPERATURA);
                    }
                    else{
                        $('#cardTemperatura').hide();
                        $("#cardTemperatura").css("display", "none");
                    }

                    if (row.HUMEDAD!=null && row.HUMEDAD.length>0){
                        $('#humedadPlanta').html(row.HUMEDAD);
                    }
                    else{
                        $('#cardHumedad').hide();
                        $("#cardHumedad").css("display", "none");
                    }

                    if (row.RIEGO!=null && row.RIEGO.length>0){
                        $('#riegoPlanta').html(row.RIEGO);
                    }
                    else{
                        $('#cardRiego').hide();
                        $("#cardRiego").css("display", "none");
                    }

                    if (row.ABONO!=null && row.ABONO.length>0){
                        $('#abonoPlanta').html(row.ABONO);
                    }
                    else{
                        $('#cardAbono').hide();
                        $("#cardAbono").css("display", "none");
                    }

                    if (row.TRASPLANTE!=null && row.TRASPLANTE.length>0){
                        $('#traslantePlanta').html(row.TRASPLANTE);
                    }
                    else{
                        $('#cardTrasplante').hide();
                        $("#cardTrasplante").css("display", "none");
                    }

                    if (row.LIMPIEZA!=null && row.LIMPIEZA.length>0){
                        $('#limpiezaPlanta').html(row.LIMPIEZA);
                    }
                    else{
                        $('#cardLimpieza').hide();
                        $("#cardLimpieza").css("display", "none");
                    }

                    if (row.PODA!=null && row.PODA.length>0){
                        $('#podaPlanta').html(row.PODA);
                    }
                    else{
                        $('#cardPoda').hide();
                        $("#cardPoda").css("display", "none");
                    }

                    if (row.MULTIPLICACION!=null && row.MULTIPLICACION.length>0){
                        $('#multiplicacionPlanta').html(row.MULTIPLICACION);
                    }
                    else{
                        $('#cardMultiplicacion').hide();
                        $("#cardMultiplicacion").css("display", "none");
                    }

                    if (row.FLORACION!=null && row.FLORACION.length>0){
                        $('#floracionPlanta').html(row.FLORACION);
                    }
                    else{
                        $('#cardFloracion').hide();
                        $("#cardFloracion").css("display", "none");
                    }

                    if (row.SUBSTRATO!=null && row.SUBSTRATO.length>0){
                        $('#substratoPlanta').html(row.SUBSTRATO);
                    }
                    else{
                        $('#cardSubstrato').hide();
                        $("#cardSubstrato").css("display", "none");
                    }

                    if (row.TRASTORNOS!=null && row.TRASTORNOS.length>0){
                        $('#trastornoPlanta').html(row.TRASTORNOS);
                    }
                    else{
                        $('#cardTrastorno').hide();
                        $("#cardTrastorno").css("display", "none");
                    }

                    if (row.DESCANSO!=null && row.DESCANSO.length>0){
                        $('#descansoPlanta').html(row.DESCANSO);
                    }
                    else{
                        $('#cardDescanso').hide();
                        $("#cardDescanso").css("display", "none");
                    }

                    if (row.INFO_ADICIONAL!=null && row.INFO_ADICIONAL.length>0){
                        $('#infoAdicionalPlanta').html(row.INFO_ADICIONAL);
                    }
                    else{
                        $('#cardInfoAdicional').hide();
                        $("#cardInfoAdicional").css("display", "none");
                    }
                }
            }
        },
    errorHandler);
}


//Detalle de la planta
$(document).on("click",'#irDetalleIndice', function ()
{
    var id = $(this).attr("ident");
    var nombre = $(this).attr("nombre");
    window.location.href = './detallePlanta.html?idPlanta='+id+'&nombre='+nombre;
});

$(document).on("touchend",'#irDetalleIndice', function ()
{
    var id = $(this).attr("ident");
    var nombre = $(this).attr("nombre");
    window.location.href = './detallePlanta.html?idPlanta='+id+'&nombre='+nombre;
});

$(document).on("click",'#nuevaPlantaDesdeIndice', function ()
{
    console.log('Nueva planta desde idIndice=>'+idPlanta);
    window.location.href = './miPlanta.html?idIndice='+idPlanta+'&';
});


//Error en populate
function errorCB(err){
    console.log("    Error processing SQL: "+err.message);
}

//OK en populate
function successCB(){
    console.log('    oK');
}

//Error al procesar sql
function errorHandler(transaction, error) {
    console.log('    Error: ' + error.message + ' code: ' + error.code);
}

$('#ubicacion').on("change",function ()
{
   mydb.transaction(populateDBFiltro, errorCB, successCB);
});

$('#flores').on("change",function ()
{
   mydb.transaction(populateDBFiltro, errorCB, successCB);
});

$('#facilidad').on("change",function ()
{
   mydb.transaction(populateDBFiltro, errorCB, successCB);
});

function populateDBFiltro(tx){
    var idUbicacion = $('#ubicacion').val();
    var idFlores = $('#flores').val();
    var idFacilidad = $('#facilidad').val();
    console.log('Id ubicacion=>'+idUbicacion+' idFlores=>'+idFlores +" idFacilidad=>"+idFacilidad);

    var query = 'select DISTINCT NOMEN.ID_PLANTA, NOMEN.NOMBRE, PLANTA.IMAGEN '
        + ' from NOMENCLATURA NOMEN, PLANTA_CATALOGO PLANTA, UBICACION_PLANTA UBIP '
        + ' where NOMEN.ID_PLANTA = PLANTA.ID_PLANTA_CATALOGO  and UBIP.ID_PLANTA = PLANTA.ID_PLANTA_CATALOGO ';

    if (idUbicacion.length >0){
        query += ' and UBIP.ID_UBICACION = '+idUbicacion;
    }

    if (idFlores.length >0){
        query += ' and PLANTA.CON_FLORES = '+idFlores;
    }

    if (idFacilidad.length >0){
        query += ' and PLANTA.FACIL = '+idFacilidad;
    }

    query+=' order by NOMEN.NOMBRE '; 

   tx.executeSql(query, [],
        function(transaction, result) {
            if (result != null && result.rows != null) {
                var datosIndiceFiltrados=[];
                for (var i = 0; i < result.rows.length; i++) {
                    var row = result.rows.item(i);
                    var fila = [''+row.ID_PLANTA,(row.IMAGEN)?''+row.IMAGEN:'', ''+row.NOMBRE];
                    datosIndiceFiltrados.push(fila);
                }
                dataTableIndice.clear();
                dataTableIndice.rows.add(datosIndiceFiltrados);
                dataTableIndice.draw();
            }
        }
    );
}